import { ActionTree, GetterTree, MutationTree } from 'vuex';
export interface StateParams {
    hasCache: boolean;
    cacheDuration: number;
    [key: string]: any;
}
export interface ModuleState {
    endpoint: string;
    loading: boolean;
    data: {
        data?: any;
        [key: string]: any;
    };
    initiallyLoaded: boolean;
    hasCache: boolean;
    cacheDuration: number;
    [key: string]: any;
}
export default class BaseModule {
    private readonly endpoint;
    private readonly defaultState;
    constructor(endpoint: string, stateParams?: StateParams);
    protected state(): ModuleState;
    protected getters(): GetterTree<ModuleState, any>;
    protected actions(): ActionTree<ModuleState, any>;
    protected mutations(): MutationTree<ModuleState>;
    getModule(): {
        namespaced: boolean;
        state: ModuleState;
        getters: GetterTree<ModuleState, any>;
        actions: ActionTree<ModuleState, any>;
        mutations: MutationTree<ModuleState>;
    };
}
