"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_isempty_1 = __importDefault(require("lodash.isempty"));
var BaseModule_1 = __importDefault(require("./BaseModule"));
var OrderDirection;
(function (OrderDirection) {
    OrderDirection["ASC"] = "asc";
    OrderDirection["DESC"] = "desc";
})(OrderDirection || (OrderDirection = {}));
var ItemsListModule = /** @class */ (function (_super) {
    __extends(ItemsListModule, _super);
    function ItemsListModule(endpoint, stateParams) {
        if (stateParams === void 0) { stateParams = { hasCache: false, cacheDuration: 3600 }; }
        return _super.call(this, endpoint, __assign(__assign({}, stateParams), { order: {} })) || this;
    }
    ItemsListModule.prototype.getters = function () {
        return __assign(__assign({}, _super.prototype.getters.call(this)), { items: function (state) { var _a; return (_a = state.data.data) !== null && _a !== void 0 ? _a : []; }, itemsExist: function (state, getters) { return getters.items.length > 0; }, 
            // eslint-disable-next-line arrow-body-style
            itemById: function (state, getters) { return function (id) {
                var _a;
                return (_a = getters.items.find(function (item) { return item.id === id; })) !== null && _a !== void 0 ? _a : null;
            }; }, order: function (state) { return state.order; }, hasOrder: function (state) { return !(0, lodash_isempty_1.default)(state.order); } });
    };
    ItemsListModule.prototype.actions = function () {
        return __assign(__assign({}, _super.prototype.actions.call(this)), { updateOrder: function (_a, name) {
                var _b;
                var commit = _a.commit, dispatch = _a.dispatch, state = _a.state;
                return __awaiter(this, void 0, void 0, function () {
                    var order, params;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                order = {
                                    value: name,
                                    direction: ((_b = state.order) === null || _b === void 0 ? void 0 : _b.direction) === OrderDirection.ASC
                                        ? OrderDirection.DESC
                                        : OrderDirection.ASC,
                                };
                                commit('SET_ORDER', order);
                                params = __assign(__assign({}, state.params), { order: order.value, direction: order.direction });
                                commit('SET_PARAMS', params);
                                return [4 /*yield*/, dispatch('get')];
                            case 1:
                                _c.sent();
                                return [2 /*return*/];
                        }
                    });
                });
            } });
    };
    ItemsListModule.prototype.mutations = function () {
        return __assign(__assign({}, _super.prototype.mutations.call(this)), { UPDATE_ONE: function (state, replace) {
                var index = state.data.data.findIndex(function (item) { return item.id === replace.id; });
                if (index > -1) {
                    state.data.data.splice(index, 1, replace);
                }
            }, APPEND_ONE: function (state, item) {
                state.data.data.push(item);
            }, REMOVE_ONE: function (state, id) {
                var index = state.data.data.findIndex(function (item) { return item.id === id; });
                if (index > -1) {
                    state.data.data.splice(index, 1);
                }
            }, SET_ORDER: function (state, order) {
                state.order = order;
            } });
    };
    return ItemsListModule;
}(BaseModule_1.default));
exports.default = ItemsListModule;
//# sourceMappingURL=ItemsListModule.js.map